/*
  BCC CHALLENGE 2 -- mar/abr 2010 -
  Bacharelado em Ciencia da Computacao
  Universidade Federal do Parana
  Lauro Luis Costa -- 'Dusty4'
*/

#include "bravo.h"
#include "comandos.h"
#include "conteudos.h"
#include "atributos.h"
#include <stdio.h>

Bravo::Bravo(int id, int x, int y, int dx, int dy) : Crianca(id, x, y)
{
    this->destX = dx;
    this->destY = dy;
    this->inimigoProx = false;
}
/*p def exibicao*/
Bravo::Bravo(int id, int x, int y, int dx, int dy, int t, int px, int py) : Crianca(id, x, y)
{
    this->destX = dx;
    this->destY = dy;
    this->inimigoProx = false;
    this->pilha->empilhar(t == 1 ? new Acao(PEGAR, NPEGAR, px, py) : new Acao(ARREMESSAR, NARREMESSAR, px, py));
    this->pilha->empilhar(new Acao(AMASSAR, NAMASSAR));
    this->pilha->empilhar(new Acao(RECOLHER, NRECOLHER, x + 1, y + 1));
    this->pilha->empilhar(new Acao(AGACHAR, NAGACHAR));


}
/*avalia e executa as acoes empilhadas previamente*/
void Bravo::jogue(Campo *c, int rodada, int placar)
{
    Acao *atual, *topo;

    if(!this->isTonta())
    {
        /*isso nao te pertence. SOLTE*/
        if(this->segurando == GRN || this->segurando == MED)
        {
            int nx, ny;
            this->procurarNeve(&nx, &ny, VAZIO0, 0, c);
            this->pilha->empilhar(new Acao(SOLTAR, NSOLTAR, nx, ny));
            c->setLocal(nx, ny, OBSTACULO_IM);
        }
        topo = this->pilha->copiaTopo();

        /*pare de andar e vamos pra briga*/
        int ncmd = topo->getNCmd();
        if((this->verificarArremessar(c) || this->verificarArremessarRev(c)) && (ncmd == NANDAR || ncmd == NAGACHAR || ncmd == NANDAR_AG || ncmd == NARREMESSAR || ncmd == NLEVANTAR || ncmd == NRECOLHER || ncmd == NSOLTAR))
        {
            this->pilha->esvaziar();
        }



        if(this->pilha->isVazia())
        {
            this->nova_pilha(c, rodada, placar);
            topo = this->pilha->copiaTopo();
        }

        if(topo->getNCmd() == NANDAR)
        {
            if(!this->verificaPasso(c, topo->getDestX(), topo->getDestY()))
            {
                /*nao estou em pe?*/
                if(this->agachado)
                    this->pilha->empilhar(new Acao(LEVANTAR, NLEVANTAR));
                /*estou muito longe do dest para andar?*/
                else if(c->distEucl(this->posX, this->posY, topo->getDestX(), topo->getDestY()) > 2)
                {
                    this->pilha->desempilhar(); /*nao quero mais essa acao*/
                    this->caminhada(c, topo->getDestX(), topo->getDestY(), false);
                    delete topo;
                    return this->jogue(c, rodada, placar);
                }
                /*obstaculo no caminho?*/
                else if(c->obstaculoEm(this->posX, this->posY, topo->getDestX(), topo->getDestY()))
                {
                    this->pilha->esvaziar();
                    this->caminhada(c);
                    return this->jogue(c, rodada, placar);
                }
            }
            else /*posso andar, vou marcar espaco ocupado*/
            {
                c->setLocal(topo->getDestX(), topo->getDestY(), CRIANCA_V);
                /*pra marcar o passo intermediario*/
                if(topo->getDestX() == this->posX)
                    c->setLocal(this->posX, this->posY + (this->posY < topo->getDestY() ? 1 : -1), CRIANCA_V);
                else if(topo->getDestY() == this->posY)
                    c->setLocal(this->posX + (this->posX < topo->getDestX() ? 1 : -1), this->posY, CRIANCA_V);
            }

        }
        if(topo->getNCmd() == NANDAR_AG)
        {
            if(!this->verificaPasso_ag(c, topo->getDestX(), topo->getDestY()))
            {
                /*nao estou em pe?*/
                if(!this->agachado)
                    this->pilha->empilhar(new Acao(AGACHAR, NAGACHAR));
                /*estou muito longe do dest para andar?*/
                else if(c->distEucl(this->posX, this->posY, topo->getDestX(), topo->getDestY()) > 1)
                {
                    this->pilha->desempilhar(); /*nao quero mais essa acao*/
                    this->caminhada(c, topo->getDestX(), topo->getDestY(), true);
                    delete topo;
                    return this->jogue(c, rodada, placar);
                }
                /*obstaculo no caminho?*/
                else if(c->obstaculoEm(this->posX, this->posY, topo->getDestX(), topo->getDestY()))
                {
                    this->pilha->esvaziar();
                    this->caminhada_ag(c);
                    return this->jogue(c, rodada, placar);
                }
            }
            else /*posso andar, vou marcar espaco ocupado*/
            {
                c->setLocal(topo->getDestX(), topo->getDestY(), CRIANCA_V);
            }

        }
    }


    atual = this->pilha->desempilhar();
    atual->imprimirAcao();
    delete atual;


}


/*decide um novo conjunto de acoes*/
void Bravo::nova_pilha(Campo *c, int rodada, int placar)
{
    /*tentar se defender pegando a bola*/
    if((this->segurando == NADA || this->segurando == PEQ1 || this->segurando == PEQ2) && this->verificarArremessarRev(c))
        return this->pilha->empilhar(new Acao(PEGAR, NPEGAR, this->alvoX, this->alvoY));
    /*se estou armado atiro*/
    if(this->segurando == PEQ1 || this->segurando == PEQ2 || this->segurando == PEQ3)
    {
        if(this->verificarArremessar(c))
            //return
            return this->pilha->empilhar(new Acao(ARREMESSAR, NARREMESSAR, this->alvoX, this->alvoY));
        if(this->agachado)
            return this->pilha->empilhar(new Acao(LEVANTAR, NLEVANTAR));
    }

    /*se desarmado recolho neve*/
    if(this->segurando == NADA)
    {
        /*o trecho abaixo compromete 3 rodadas, estou sendo muito atingido durante elas, o proximo if eh um teste p melhorar isso*/
        if(!this->agachado)
            return this->pilha->empilhar(new Acao(AGACHAR, NAGACHAR));

        int neveX, neveY;
        /*bola de neve pronta*/
        if(this->procurarNeve(&neveX, &neveY, BOLAPEQ, 1, c))
        {
            c->setLocal(neveX, neveY, OBSTACULO_IM);
            this->pilha->empilhar(new Acao(RECOLHER, NRECOLHER, neveX, neveY));
        }
        else
        {
            /*neve solta*/
            if(this->procurarNeve(&neveX, &neveY, VAZIO0, 1, c))
            {
                this->pilha->empilhar(new Acao(AMASSAR, NAMASSAR));
                this->pilha->empilhar(new Acao(RECOLHER, NRECOLHER, neveX, neveY));
                c->setLocal(neveX, neveY, OBSTACULO_IM);
            }
            /*se nao tem neve solta, anda um pouco*/
            else
            {
                this->pilha->esvaziar();
                return caminhada(c, this->destAleatoria(this->posX, 2), this->destAleatoria(this->posY, 2), true);
            }
        }
        /*deve estar agachado*/
        if(!this->agachado)
            this->pilha->empilhar(new Acao(AGACHAR, NAGACHAR));

        return;
    }

    /*um inimigo para pelo menos andar na direcao?*/
    int indx = c->procuraInimigo_cache(this->posX, this->posY, 100);
    /*ando na direcao do adversaio... */
    if(indx != -1)
    {
        /*ja estou perto, me posiciono melhor*/
        if(c->procuraInimigo_cache(this->posX, this->posY, 10) != -1)
        {
            this->destX = this->destAleatoria(this->posX, 3);
            this->destY = this->destAleatoria(this->posY, 3);
        }
        else
        {
            this->destX = c->getPosX_cache(indx);
            this->destY = c->getPosY_cache(indx);
        }
        return caminhada(c, this->destX, this->destY, false);
    }

    /*andar faz bem...*/
    return this->caminhada(c);
}

