/*
  BCC CHALLENGE 2 -- mar/abr 2010 -
  Bacharelado em Ciencia da Computacao
  Universidade Federal do Parana
  Lauro Luis Costa -- 'Dusty4'
*/


#include "bulldozer.h"
#include <stdlib.h>
#include <time.h>

Bulldozer::Bulldozer(FILE *fptr)
{
    this->placar = 0;
    this->rodada = 0;
    this->fp = fptr;
}

void Bulldozer::run()
{
    this->campoAtual = new Campo();
    this->campoAtual->le_entrada(&(this->placar), &(this->rodada), fp);
    srand(time(0));


    int n, m;
    int* cx0 = new int[10];
    int* cy0 = new int[10];
    int* cx2 = new int[10];
    int* cy2 = new int[10];
    int* cx3 = new int[10];
    int* cy3 = new int[10];

    cx0[1] = 5; cy0[1] = 15;
    cx0[0] = 5; cy0[0] = 26;
    cx2[0] = 4; cy2[0] = 4;
    cx3[1] = 15; cy3[1] = 5;
    cx3[0] = 26; cy3[0] = 5;

    if((random() & 1) == 0)
    {
        n = 30; m = 100;
    }
    else
    {
        m = 30; n = 100;
    }

    this->jogador[0] = new Charlie(0, this->campoAtual->getPosX_cache(0), this->campoAtual->getPosY_cache(0), cx0, cy0, 1, n);
    this->jogador[1] = new Bravo(1, this->campoAtual->getPosX_cache(1), this->campoAtual->getPosY_cache(1), 30, 30);
    this->jogador[2] = new Charlie(2, this->campoAtual->getPosX_cache(2), this->campoAtual->getPosY_cache(2), cx2, cy2, 0, 0);
    this->jogador[3] = new Charlie(3, this->campoAtual->getPosX_cache(3), this->campoAtual->getPosY_cache(3), cx3, cy3, 1, m);


    while(this->rodada != -1)
    {
        for(int i = 0; i < 4; i++)
        {
            this->jogador[i]->jogue(this->campoAtual, this->rodada, this->placar);
            if(this->jogador[i]->mudar)
            {
                delete this->jogador[i];
                this->jogador[i] = new Bravo(i, this->campoAtual->getPosX_cache(i), this->campoAtual->getPosY_cache(i), 15, 15);
            }
        }
        this->campoAtual->le_entrada(&(this->placar), &(this->rodada), fp);

        for(int i = 0; i < 4; i++)
            this->atualizarJogador(this->jogador[i], this->campoAtual, i);
    }

}

void Bulldozer::atualizarJogador(Crianca *k, Campo *c, int i)
{
    k->setAgachado(c->getAgachado_cache(i));
    k->setPosXY(c->getPosX_cache(i), c->getPosY_cache(i));
    k->setSegurando(c->getSegurando_cache(i));
    k->setTonta(c->getTonta_cache(i));
}

