/*
  BCC CHALLENGE 2 -- mar/abr 2010 -
  Bacharelado em Ciencia da Computacao
  Universidade Federal do Parana
  Lauro Luis Costa -- 'Dusty4'
*/

#include "campo.h"
#include "conteudos.h"
#include <stdlib.h>
#include <math.h>
#include "atributos.h"

Campo::Campo()
{
    this->ocupado_cache = 8;
    for(int i = 0; i < CAMPO_SZ; i++)
        for(int j = 0; j < CAMPO_SZ; j++)
            this->matrizCampo[i][j] = 0;

}

int Campo::getLocal(int x, int y)
{
    return this->matrizCampo[x][y];
}

void Campo::le_entrada(int *Pts, int *rodada, FILE *fp)
{

/*ler rodada e placar*/
    int redPts, bluePts;
    fscanf(fp, "%d", rodada);
    if(*rodada == -1)
        return;
    fscanf(fp, "%d %d\n", &redPts, &bluePts);
    *Pts = redPts - bluePts;

    this->ocupado_cache = 8;

/*ler o campo*/
    char temp[100];
    for(int i = 0; i < CAMPO_SZ; i++)
    {
        fgets(temp, 100, fp);
        for(int j = 0; j < CAMPO_SZ; j++)
        {
            int conteudo = this->traduzConteudo(temp, 3 * j);
            /*arvores nao se mexem, eu nao vou mais esquecer onde elas estao*/
            if(conteudo == DESCONHECIDO && this->matrizCampo[i][j] == ARVORE)
                conteudo = ARVORE;

            this->matrizCampo[i][j] = conteudo;
            /*arvores estao dispostas simetricamente, entao duplico a informacao*/
            if(conteudo == ARVORE)
                this->matrizCampo[30 - i][30 - j] = ARVORE;

            this->atualizaCache(i, j, temp[3 * j + 1]);
        }

    }

/*ler informacoes dos jogadores*/

    for(int i = 0; i < 8; i++)
    {
        fgets(temp, 100, fp);
        /*traducao*/
        if((this->visivel_cache[i] = (temp[0] != '*')))
        {
            char p;
            sscanf(temp, "%d %d %c %c %d",
            &(this->posX_cache[i]), &(this->posY_cache[i]), &p, &(this->segurando_cache[i]), &(this->tonta_cache[i]));
            if((this->agachado_cache[i] = (p == 'C')))
                this->alturaObj_cache[i] = 6;
            else
                this->alturaObj_cache[i] = 9;

            /*marcar essa info no campo*/
            if(i < 4)
                this->matrizCampo[this->posX_cache[i]][this->posY_cache[i]] = this->agachado_cache[i] ? CRIANCA_V_AG : CRIANCA_V;
            else
                this->matrizCampo[this->posX_cache[i]][this->posY_cache[i]] = this->agachado_cache[i] ? CRIANCA_A_AG : CRIANCA_A;
        }
    }
}

int Campo::traduzConteudo(char *origem, int pos)
{
    char p1, p2[2];
    p1 = origem[pos + 1];
    p2[0] = origem[pos];
    p2[1] = 0;

    switch (p1)
    {
    	case '*':
            return DESCONHECIDO;
        case 'a':
            return atoi(p2);
        case 'b':
            return ARVORE;
        case 'c':
            return BOLAPEQ + atoi(p2);
        case 'd':
            return BOLAMED + atoi(p2);
        case 'e':
            return BOLAMED_PEQ + atoi(p2);
        case 'f':
            return BOLAGRN + atoi(p2);
        case 'g':
            return BOLAGRN_MED + atoi(p2);
        case 'h':
            return BOLAGRN_PEQ + atoi(p2);
        case 'i':
            return BONECO_V + atoi(p2);
        case 'j':
            return BONECO_A + atoi(p2);
        default:
            return -1;
    }
}
/*atualiza ponto interessante na cache de localizacoes*/
void Campo::atualizaCache(int x, int y, char a)
{
    int pos = this->ocupado_cache;
    if(pos >= CACHE_SZ)
    {
        return;
    }
    switch (a)
    {
        case 'b':
            this->alturaObj_cache[pos] = 9;
            this->posX_cache[pos] = x;
            this->posY_cache[pos] = y;
            this->obj_cache[pos] = ARVORE;
            this->visivel_cache[pos] = true;
            /*considerando a simetria do campo*/
            pos = ++this->ocupado_cache;
            this->alturaObj_cache[pos] = 9;
            this->posX_cache[pos] = 30 - x;
            this->posY_cache[pos] = 30 - y;
            this->obj_cache[pos] = ARVORE;
            this->visivel_cache[pos] = true;
            break;
        case 'i':
            this->alturaObj_cache[pos] = 6;
            this->posX_cache[pos] = x;
            this->posY_cache[pos] = y;
            this->obj_cache[pos] = BONECO_V;
            this->visivel_cache[pos] = true;
            break;
        case 'j':
            this->alturaObj_cache[pos] = 6;
            this->posX_cache[pos] = x;
            this->posY_cache[pos] = y;
            this->obj_cache[pos] = BONECO_A;
            this->visivel_cache[pos] = true;
            break;
        default:
            return;
    }
    this->ocupado_cache++;
    return;
}

/*retorna altura do ponto baseado na definicao dos conteudos*/
int Campo::getAltura(int x, int y)
{
    return this->matrizCampo[x][y] % 10;
}
/*retorna a dist euclidiana entre p0 e p1*/
float Campo::distEucl(int x0, int y0, int x1, int y1)
{
    return sqrt(((x0 - x1) * (x0 - x1)) + ((y0 - y1) * (y0 - y1)));
}

/*verifica obstaculo no caminho de xy ate dxdy*/
bool Campo::obstaculoEm(int x, int y, int dx, int dy, int altura)
{
    if(!this->coordValida(dx, dy))
        return true;

    /*diagonal*/
    if(x != dx && y != dy)
        return getAltura(dx, dy) >= altura;

    /*apenas um passo horizontal*/
    if(abs(dx - x) == 1)
        return getAltura(dx, y) >= altura;

    /*apenas um passo vertical*/
    if(abs(dy - y) == 1)
        return getAltura(x, dy) >= altura;

    /*somente em x, verificar passo final e intermediario*/
    if(y == dy)
        return getAltura(dx, dy) >= altura || getAltura(dx + (x < dx ? -1 : 1 ), y) >= altura;

    /*somente em y, verificar passo final e intermediario*/
    return getAltura(dx, dy) >= altura || getAltura(x, dy + (y < dy ? -1 : 1)) >= altura;
}
/*6 e obstaculo para caminhada, essse metodo costumava ser
chamado apenas para consultar esse tipo de obstaculo, em movimento de caminhada*/
bool Campo::obstaculoEm(int x, int y, int dx, int dy)
{
    return this->obstaculoEm(x, y, dx, dy, 6);
}
/*marca posicao do campo*/
void Campo::setLocal(int x, int y, int obj)
{
    this->matrizCampo[x][y] = obj;
}
/*recebe uma coord e um obj,
retorna o indice do obj mais proximo desse ponto ou -1*/
int Campo::procuraObj_cache(int x0, int y0, int obj)
{
    if(obj == CRIANCA_V || obj == CRIANCA_V_AG)
        return 0; /*implementar se necessario*/

    if(obj == CRIANCA_A || obj == CRIANCA_A_AG)
        return this->procuraInimigo_cache(x0, y0, 100);


    int p = -1;
    float dist2;
    float dist = 100;
    for(int i = N_CRIANCAS * 2; i <= this->ocupado_cache; i++)
        if(this->obj_cache[i] == obj)
        {
            dist2 = this->distEucl(x0, y0, this->posX_cache[i], this->posY_cache[i]);
            if(dist2 < dist)
            {
                p = i;
                dist = dist2;
            }
        }
    return p;
}
/*retorna o inimigo mais proximo ou -1*/
int Campo::procuraInimigo_cache(int x0, int y0, int dmax)
{
    int p = -1;
    float dist =  dmax;
    float dist2;
    for(int i = N_CRIANCAS; i < N_CRIANCAS * 2; i++)
        if(this->visivel_cache[i])
        {
            dist2 = this->distEucl(x0, y0, this->posX_cache[i], this->posY_cache[i]);
            if(dist2 < dist)
            {
                dist = dist2;
                p = i;
            }
        }

    return p;
}

/*os proximos metodos retornam uma entrada da cache*/
int Campo::getPosX_cache(int indx)
{
    return this->posX_cache[indx];
}
int Campo::getPosY_cache(int indx)
{
    return this->posY_cache[indx];
}
bool Campo::getAgachado_cache(int indx)
{
    return this->agachado_cache[indx];
}
char Campo::getSegurando_cache(int indx)
{
    return this->segurando_cache[indx];
}
int Campo::getTonta_cache(int indx)
{
    return this->tonta_cache[indx];
}
bool Campo::getVisivel_cache(int indx)
{
    return this->visivel_cache[indx];
}
int Campo::getObj_cache(int indx)
{
    return this->obj_cache[indx];
}
int Campo::getAlturaObj_cache(int indx)
{
    return this->alturaObj_cache[indx];
}
/*fim dos metodos que retornam entradas da cache*/
/*modificar info na cache*/
void Campo::setObj_cache(int indx, int o)
{
    this->obj_cache[indx] = o;
}


/*retorna uma matriz
a iesima linha contem todos os vizinhos da pos i*/
void Campo::montaListaVizinhanca(int lista[CAMPO_SZ * CACHE_SZ][12], bool agachado)
{
    for(int i = 0; i < CAMPO_SZ; i++)
        for(int j = 0; j < CAMPO_SZ; j++)
        {

            int k = 0;
            /*diagonal abaixo esquerda*/
            if(!agachado)
            {
                if(this->coordValida(i - 1, j - 1) && !this->obstaculoEm(i, j, i - 1, j - 1))
                    lista[i * CAMPO_SZ + j][k++] = (i - 1) * CAMPO_SZ + j - 1;
                /*diagonal abaixo direita*/
                if(this->coordValida(i - 1, j + 1) && !this->obstaculoEm(i, j, i - 1, j + 1))
                    lista[i * CAMPO_SZ + j][k++] = (i - 1) * CAMPO_SZ + j + 1;
                /*diagonal acima esquerda*/
                if(this->coordValida(i + 1, j - 1) && !this->obstaculoEm(i, j, i + 1, j - 1))
                    lista[i * CAMPO_SZ + j][k++] = (i + 1) * CAMPO_SZ + j - 1;
                /*diagonal acima direita*/
                if(this->coordValida(i + 1, j + 1) && !this->obstaculoEm(i, j, i + 1, j + 1))
                    lista[i * CAMPO_SZ + j][k++] = (i + 1) * CAMPO_SZ + j + 1;
                /*dois passos abaixo*/
                if(this->coordValida(i - 2, j) && !this->obstaculoEm(i, j, i - 2, j))
                    lista[i * CAMPO_SZ + j][k++] = (i - 2) * CAMPO_SZ + j;
                /*dois passos acima*/
                if(this->coordValida(i + 2, j) && !this->obstaculoEm(i, j, i + 2, j))
                    lista[i * CAMPO_SZ + j][k++] = (i + 2) * CAMPO_SZ + j;
                /*dois passos a esquerda*/
                if(this->coordValida(i, j - 2) && !this->obstaculoEm(i, j, i, j - 2))
                    lista[i * CAMPO_SZ + j][k++] = (i) * CAMPO_SZ + j - 2;
                /*dois passos a direita*/
                if(this->coordValida(i, j + 2) && !this->obstaculoEm(i, j, i, j + 2))
                    lista[i * CAMPO_SZ + j][k++] = (i) * CAMPO_SZ + j + 2;
            }
            /*um passo abaixo*/
            if(this->coordValida(i - 1, j) && !this->obstaculoEm(i, j, i - 1, j))
                lista[i * CAMPO_SZ + j][k++] = (i - 1) * CAMPO_SZ + j;
            /*um passo acima*/
             if(this->coordValida(i + 1, j) && !this->obstaculoEm(i, j, i + 1, j))
                lista[i * CAMPO_SZ + j][k++] = (i + 1) * CAMPO_SZ + j;
            /*um passo a esquerda*/
             if(this->coordValida(i, j - 1) && !this->obstaculoEm(i, j, i, j - 1))
                lista[i * CAMPO_SZ + j][k++] = (i) * CAMPO_SZ + j - 1;
            /*um passo a direita*/
            if(this->coordValida(i, j + 1) && !this->obstaculoEm(i, j, i, j + 1))
                lista[i * CAMPO_SZ + j][k++] = (i) * CAMPO_SZ + j + 1;
            /*se nao tinha alguma vizinhanca, marco fim da linha com -1*/
            if(k < 12)
                lista[i * CAMPO_SZ + j][k] = -1;
        }
}

/*usando busca em largura, faz uma listas com os passos
para chegar em p1 a partir de p0 se ele existir*/
bool Campo::constroiCaminho(int x0, int y0, int x1, int y1, int *listax, int *listay, bool agachado)
{
    int listaViz[CAMPO_SZ * CAMPO_SZ][12];

    int pai[CAMPO_SZ * CAMPO_SZ];
    int fila[CAMPO_SZ * CAMPO_SZ];
    bool visitado[CAMPO_SZ * CAMPO_SZ];
    int in_fila = 0;
    int fim_fila = 0;
    int raiz = x0 * CAMPO_SZ + y0;
    int procurado = x1 * CAMPO_SZ + y1;

    if(procurado == raiz)
        return false; /*nunca se sabe*/

    for(int i = 0; i < CAMPO_SZ * CAMPO_SZ; i++)
    {
        pai[i] = 0;
        fila[i] = 0;
        visitado[i] = false;
    }


    this->montaListaVizinhanca(listaViz, agachado);
    /*lista montada, rodar a busca*/


    fila[fim_fila++] = raiz;
    pai[raiz] = -1;
    while(fila[in_fila] != procurado)
    {
        int atual = fila[in_fila++];
        for(int i = 0; i < 12 && listaViz[atual][i] != -1; i++)
            if(!visitado[listaViz[atual][i]])
            {
                fila[fim_fila] = listaViz[atual][i];
                pai[fila[fim_fila++]] = atual;
                visitado[listaViz[atual][i]] = true;
            }
        if(in_fila == fim_fila)
        {
            return false;
        }
    }

    /*o caminho esta gravado no vetor pai, basta traduzi lo e colocar nas listasXY*/
    for(int i = 0; i < CAMPO_SZ * CAMPO_SZ && procurado != -1; i++)
    {
        listax[i] = procurado / CAMPO_SZ;
        listay[i] = procurado % CAMPO_SZ;
        procurado = pai[procurado];
    }

    return true;
}

/*retorna o amigo mais proximo desse inimigo ou -1*/
int Campo::proximoDoInimigo(int x0, int y0, int dmax)
{
    int p = -1;
    for(int i = 0; i < N_CRIANCAS; i++)
        if(this->distEucl(x0, y0, this->posX_cache[i], this->posY_cache[i]) < dmax
        && (p == -1  || this->distEucl(x0, y0, this->posX_cache[i], this->posY_cache[i]) < this->distEucl(x0, y0, this->posX_cache[p], this->posY_cache[p])))
            p = i;

    return p;
}

/*multiplica o compr do vetor X0 X1 em d vezes*/
void Campo::posAlem(int x0, int y0, int *x1, int *y1, int d)
{
    int dx = (*x1 - x0) * d;
    int dy = (*y1 - y0) * d;
    *x1 = x0 + dx;
    *y1 = y0 + dy;
}
/*retorna verdadeiro se o primeiro obstaculo encontrado e do tipo alvo*/
bool Campo::verificarAcerto(int x0, int y0, int x1, int y1, int altura, int alvo)
{
    int dx = abs(x1 - x0);
    int dy = abs(y1 - y0);

    int n = dx > dy ? dx : dy;

    dx = x1 - x0;
    dy = y1 - y0;

    int altura_atual;

    for(int t = 1; t <= n; t++)
    {
        double tmp;
        tmp = (double) 9 * t / n;
        altura_atual = altura - round(tmp);

        tmp = (double) dx * t / n;
        int xp = x0 + round(tmp);

        tmp = (double) dy * t / n;
        int yp = y0 + round(tmp);

        if(!this->coordValida(xp, yp))
            return false;
        if(this->getAltura(xp, yp) >= altura_atual && this->getLocal(xp, yp) != OBSTACULO_IM)
            return this->matrizCampo[xp][yp] == alvo;

    }
    return false;
}

