/*
  BCC CHALLENGE 2 -- mar/abr 2010 -
  Bacharelado em Ciencia da Computacao
  Universidade Federal do Parana
  Lauro Luis Costa -- 'Dusty4'
*/


#ifndef CAMPO_H_INCLUDED
#define CAMPO_H_INCLUDED
#include <stdio.h>
#define N_CRIANCAS 4
#define CACHE_SZ 1024
#define CAMPO_SZ 31
class Campo
{
        int matrizCampo[CAMPO_SZ][CAMPO_SZ];
        int posX_cache[CACHE_SZ];
        int posY_cache[CACHE_SZ];
        bool agachado_cache[N_CRIANCAS * 2];
        char segurando_cache[N_CRIANCAS * 2];
        int tonta_cache[N_CRIANCAS * 2];
        bool visivel_cache[N_CRIANCAS * 2];
        int obj_cache[CACHE_SZ];
        int alturaObj_cache[CACHE_SZ];
        int ocupado_cache;
        void montaListaVizinhanca(int lista[CAMPO_SZ * CAMPO_SZ][12], bool agachado);
        int traduzConteudo(char *origem, int pos);
        void atualizaCache(int x, int y, char a);
        bool coordValida(int x, int y) { return (x >= 0 && x <= 30 && y >=0 && y <=30); }
        void posAlem(int x0, int y0, int *x1, int *y1, int d);

	public:
        Campo();
		void le_entrada(int *Pts, int *rodada, FILE *fp);
		int getLocal(int x, int y);
		void setLocal(int x, int y, int obj);
        float distEucl(int x0, int y0, int x1, int y1);
		int getPosX_cache(int indx);
		int getPosY_cache(int indx);
		bool getAgachado_cache(int indx);
		char getSegurando_cache(int indx);
		int getTonta_cache(int indx);
		bool getVisivel_cache(int indx);
		int getObj_cache(int indx);
		int getAlturaObj_cache(int indx);
		int getAltura(int x, int y);
		void setObj_cache(int indx, int o);
		bool obstaculoEm(int x, int y, int dx, int dy);
        bool obstaculoEm(int x, int y, int dx, int dy, int altura);
		bool constroiCaminho(int x0, int y0, int x1, int y1, int *listax, int *listay, bool agachado);
		int procuraObj_cache(int x0, int y0, int obj);
		int procuraInimigo_cache(int x0, int y0, int dmax);
		int proximoDoInimigo(int x0, int y0, int dmax);
        bool verificarAcerto(int x0, int y0, int x1, int y1, int altura, int alvo);
};


#endif // CAMPO_H_INCLUDED
