/*
  BCC CHALLENGE 2 -- mar/abr 2010 -
  Bacharelado em Ciencia da Computacao
  Universidade Federal do Parana
  Lauro Luis Costa -- 'Dusty4'
*/


#include "charlie.h"
#include "comandos.h"
#include "conteudos.h"
#include "atributos.h"
#include <stdlib.h>
Charlie::Charlie(int id, int x, int y, int *cx, int *cy, int ctopo, int l) : Crianca(id, x, y)
{
    this->construindo = false;
    this->roubando = false;
    this->contraAtaque = false;
    this->sobAtaque = 0;
    this->destX = cx[ctopo];
    this->destY = cy[ctopo];
    this->bonecoX = cx;
    this->bonecoY = cy;
    this->boneco_topo = ctopo - 1;
    this->lim = l;
}
/*p def exibicao*/
Charlie::Charlie(int id, int x, int y, int *cx, int *cy, int ctopo, int px, int py) : Crianca(id, x, y)
{
    this->construindo = false;
    this->roubando = false;
    this->contraAtaque = false;
    this->sobAtaque = 0;
    this->destX = cx[ctopo];
    this->destY = cy[ctopo];
    this->bonecoX = cx;
    this->bonecoY = cy;
    this->boneco_topo = ctopo - 1;

    this->pilha->empilhar(new Acao(ARREMESSAR, NARREMESSAR, px, py));
    this->pilha->empilhar(new Acao(AMASSAR, NAMASSAR));
    this->pilha->empilhar(new Acao(RECOLHER, NRECOLHER, x + 1, y + 1));
    this->pilha->empilhar(new Acao(AGACHAR, NAGACHAR));
}

void Charlie::jogue(Campo *c, int rodada, int placar)
{
    Acao *atual, *topo;

    if(!this->isTonta())
    {
        int indx;
        /*contra atacar*/
        if(this->sobAtaque > 0)
        {
            this->sobAtaque--;
            this->contraAtaque = false;
            if(this->segurando == PEQ1 || this->segurando == PEQ2 || this->segurando == PEQ3)
            {
                if(this->verificarArremessar(c, &(this->sobAtaqueX), &(this->sobAtaqueY)))
                {
                        this->contraAtaque = true;
                        this->pilha->empilhar(new Acao(ARREMESSAR, NARREMESSAR, this->sobAtaqueX, this->sobAtaqueY));
                }
                else
                {
                    /*tentar atirar em pe*/
                    if(this->agachado)
                    {
                        this->pilha->empilhar(new Acao(LEVANTAR, NLEVANTAR));
                        this->sobAtaque++;
                    }
                    else
                    {
                        /*sem alvo, soltar*/
                        int x0, y0;
                        this->procurarNeve(&x0, &y0, VAZIO0, 0, c);

                        this->pilha->empilhar(new Acao(SOLTAR, -NSOLTAR, x0, y0));
                        c->setLocal(x0, y0, OBSTACULO_IM);
                    }
                }
            }
            /*houve engano, eu queria c-a mas nao tem nenuhma bola de neve comigo*/
            else
                this->sobAtaque = 0;
        }
        if(this->verificarArremessarRev(c, &(this->sobAtaqueX), &(this->sobAtaqueY)))
        {
            if(this->segurando == NADA || this->segurando == PEQ1 || this->segurando == PEQ2)
            {
                /*para nao ter que ficar tratando muito, apenas deleto o ataque caso eu queira pegar de novo em vez de ja contra atacar*/
                if(this->pilha->copiaTopo()->getNCmd() == NARREMESSAR || this->pilha->copiaTopo()->getNCmd() == -NSOLTAR)
                    delete this->pilha->desempilhar();
                this->pilha->empilhar(new Acao(PEGAR, NPEGAR, this->sobAtaqueX, this->sobAtaqueY));
                this->sobAtaque++;
            }
        }
        else if(this->sobAtaque <= 0 && !this->contraAtaque)
        {
            this->sobAtaque = 0; /*caso tenha baixado de 0 por algum erro*/
            if(!(this->construindo) && (indx = (c->procuraObj_cache(this->posX, this->posY, BONECO_A))) != -1)
            {

                if(!this->roubando || c->distEucl(this->posX, this->posY, this->destX, this->destY) >= 2)
                {
                    this->roubando = true;
                    if(this->destX != c->getPosX_cache(indx) || this->destY != c->getPosY_cache(indx))
                    {
                        this->destX = c->getPosX_cache(indx);
                        this->destY = c->getPosY_cache(indx);
                        this->pilha->esvaziar();
                        /*o novo boneco mais proximo esta muito proximo*/
                        if(c->distEucl(this->posX, this->posY, this->destX, this->destY) >= 2)
                            this->caminhada(c);
                    }
                    c->setObj_cache(indx, OBSTACULO_IM);
                }
                else
                    this->pilha->esvaziar(); /*soh pra garantir*/
            }
            if(this->pilha->isVazia())
                this->nova_pilha(c, rodada, placar);

            topo = this->pilha->copiaTopo();
            if(topo->getNCmd() == NANDAR)
            {
                if(!this->verificaPasso(c, topo->getDestX(), topo->getDestY()))
                {
                    /*nao estou em pe?*/
                    if(this->agachado)
                        this->pilha->empilhar(new Acao(LEVANTAR, NLEVANTAR));
                    /*estou muito longe do dest para andar?*/
                    else if(c->distEucl(this->posX, this->posY, topo->getDestX(), topo->getDestY()) > 2)
                    {
                        this->caminhada(c, topo->getDestX(), topo->getDestY(), false);
                        delete this->pilha->desempilhar(); /*nao quero mais essa acao*/
                        return this->jogue(c, rodada, placar);
                    }
                    /*obstaculo no caminho?*/
                    else if(c->obstaculoEm(this->posX, this->posY, topo->getDestX(), topo->getDestY()))
                    {
                        this->pilha->esvaziar();
                        this->caminhada(c);
                        return this->jogue(c, rodada, placar);
                    }
                }
                else /*posso andar, vou marcar espaco ocupado*/
                {
                    c->setLocal(topo->getDestX(), topo->getDestY(), CRIANCA_V);
                    /*pra marcar o passo intermediario*/
                    if(topo->getDestX() == this->posX)
                        c->setLocal(this->posX, this->posY + (this->posY < topo->getDestY() ? 1 : -1), CRIANCA_V);
                    else if(topo->getDestY() == this->posY)
                        c->setLocal(this->posX + (this->posX < topo->getDestX() ? 1 : -1), this->posY, CRIANCA_V);
                }

            }

            if(topo->getNCmd() == NANDAR_AG)
            {
                if(!this->verificaPasso_ag(c, topo->getDestX(), topo->getDestY()))
                {
                    /*nao estou em pe?*/
                    if(!this->agachado)
                        this->pilha->empilhar(new Acao(AGACHAR, NAGACHAR));
                    /*estou muito longe do dest para andar?*/
                    else if(c->distEucl(this->posX, this->posY, topo->getDestX(), topo->getDestY()) > 1)
                    {
                        this->pilha->desempilhar(); /*nao quero mais essa acao*/
                        this->caminhada(c, topo->getDestX(), topo->getDestY(), true);
                        delete topo;
                        return this->jogue(c, rodada, placar);
                    }
                    /*obstaculo no caminho?*/
                    else if(c->obstaculoEm(this->posX, this->posY, topo->getDestX(), topo->getDestY()))
                    {
                        this->pilha->esvaziar();
                        this->caminhada_ag(c);
                        return this->jogue(c, rodada, placar);
                    }
                }
                else /*posso andar, vou marcar espaco ocupado*/
                {
                    c->setLocal(topo->getDestX(), topo->getDestY(), CRIANCA_V);
                }

            }
            if(topo->getNCmd() == NRECOLHER && !this->agachado)
                this->pilha->empilhar(new Acao(AGACHAR, NAGACHAR));

        }
    }

    atual = this->pilha->desempilhar();
    atual->imprimirAcao();
    delete atual;

    this->contraAtaque = false;

}

void Charlie::nova_pilha(Campo *c, int rodada, int placar)
{
    int indx;

    if(this->construindo)
    {
        if((indx = (c->procuraObj_cache(this->posX, this->posY, BONECO_A))) != -1)
        {
            this->roubando = true;
            this->destX = c->getPosX_cache(indx);
            this->destY = c->getPosY_cache(indx);
            c->setObj_cache(indx, OBSTACULO_IM);
        }
        else
        {
            this->roubando = false;
            if(this->boneco_topo < 0)
            {

                if(this->lim < rodada)
                    this->mudar = true;

                if(!this->regiaoDesc(c, 3))
                    this->mudar = true;
            }
            else
            {
                this->destX = this->bonecoX[this->boneco_topo];
                this->destY = this->bonecoY[this->boneco_topo];
                this->boneco_topo--;
            }
        }
        /*se eu estou construindo e a pilha esta vazia eh pq terminei* de construir*/
        this->construindo = false;
        return this->caminhada(c);
    }

    /*ver se cheguei no destino*/
    if(this->roubando)
    {
        indx = c->procuraObj_cache(this->posX, this->posY, BONECO_A);
        /*cheguei no local do roubo?*/
        if(indx == -1)
        {
            this->roubando = false; /*sumiu!*/
        }
        else
        {
            if(c->distEucl(this->posX, this->posY, c->getPosX_cache(indx), c->getPosY_cache(indx)) >= 2)
            {
                this->destX = c->getPosX_cache(indx);
                this->destY = c->getPosY_cache(indx);

                return this->caminhada(c);
            }
            /*preparar as maos para o roubo*/
            if(this->segurando != NADA)
            {
                int neveX, neveY;
                this->procurarNeve(&neveX, &neveY, VAZIO0, 0, c);
                this->pilha->empilhar(new Acao(SOLTAR, NSOLTAR, neveX, neveY));
                return;
            }
            /*roubar a cabeca e colocar de volta*/
            this->alvoX = c->getPosX_cache(indx);
            this->alvoY = c->getPosY_cache(indx);
            this->pilha->empilhar(new Acao(LEVANTAR, NLEVANTAR));
            c->setObj_cache(indx, OBSTACULO_IM);
            this->pilha->empilhar(new Acao(SOLTAR, NSOLTAR, this->alvoX, this->alvoY));
            this->pilha->empilhar(new Acao(RECOLHER, NRECOLHER, this->alvoX, this->alvoY));
            if(!this->agachado)
                this->pilha->empilhar(new Acao(AGACHAR, NAGACHAR));
            this->construindo = true;
            this->roubando = false;
            return;
        }
    }
    if(c->distEucl(this->posX, this->posY, this->destX, this->destY) > 1)
        return this->caminhada(c);


    /*preparar as maos para fazer boneco*/
    if(this->segurando != NADA)
    {
        int neveX, neveY;
        this->procurarNeve(&neveX, &neveY, VAZIO0, 0, c);
        this->pilha->empilhar(new Acao(SOLTAR, NSOLTAR, neveX, neveY));
        return;
    }
    /*fazer um boneco de neve*/
    int dx1, dx2, dx3, dy1, dy2, dy3;
    if( !this->procurarNeve(&dx3, &dy3, VAZIO0, 3, c)
    ||  !this->procurarNeve(&dx2, &dy2, VAZIO0, 2, c)
    ||  !this->procurarNeve(&dx1, &dy1, VAZIO0, 1, c))
    {
        this->destX = this->destAleatoria(this->posX, 2);
        this->destY = this->destAleatoria(this->posY, 2);
        this->caminhada(c);
        return;
    }


    /*fazer o boneco em um lugar bem alto*/
    if(!((this->procurarNeve(&(this->alvoX), &(this->alvoY), VAZIO0, 3, c, 15, 15))
    ||   (this->procurarNeve(&(this->alvoX), &(this->alvoY), VAZIO0, 2, c, 15, 15))
    ||   (this->procurarNeve(&(this->alvoX), &(this->alvoY), VAZIO0, 1, c, 15, 15))))
    {
        this->alvoX = dx3;
        this->alvoY = dy3;
    }
    /*evitar que alguem pise onde estou pegando neve...*/
    c->setLocal(dx3, dy3, OBSTACULO_IM);
    c->setLocal(dx2, dy2, OBSTACULO_IM);
    c->setLocal(dx1, dy1, OBSTACULO_IM);
    c->setLocal(this->alvoX, this->alvoY, OBSTACULO_IM);

    /*cabeca*/
    this->pilha->empilhar(new Acao(SOLTAR, NSOLTAR, this->alvoX, this->alvoY));
    this->pilha->empilhar(new Acao(AMASSAR, NAMASSAR));
    this->pilha->empilhar(new Acao(RECOLHER, NRECOLHER, dx1, dy1));
    /*corpo*/
    this->pilha->empilhar(new Acao(SOLTAR, NSOLTAR, this->alvoX, this->alvoY));
    this->pilha->empilhar(new Acao(AMASSAR, NAMASSAR));
    this->pilha->empilhar(new Acao(RECOLHER, NRECOLHER, dx2, dy2));
    this->pilha->empilhar(new Acao(RECOLHER, NRECOLHER, dx2, dy2));

    /*base*/
    this->pilha->empilhar(new Acao(SOLTAR, NSOLTAR, this->alvoX, this->alvoY));
    this->pilha->empilhar(new Acao(AMASSAR, NAMASSAR));
    this->pilha->empilhar(new Acao(RECOLHER, NRECOLHER, dx3, dy3));
    this->pilha->empilhar(new Acao(RECOLHER, NRECOLHER, dx3, dy3));
    this->pilha->empilhar(new Acao(RECOLHER, NRECOLHER, dx3, dy3));
    if(!this->agachado)
        this->pilha->empilhar(new Acao(AGACHAR, NAGACHAR));
    this->construindo = true;
    return;

}

/*onde esta a regiao desconhecida mais proxima
em numero de passos e nao dist euclidiana*/
bool Charlie::regiaoDesc(Campo *c, int k)
{
    int passos = 1000;
    for(int i = k; i < CAMPO_SZ - k; i++)
        for(int j = k; j < CAMPO_SZ - k; j++)
            if(c->getLocal(i, j) == DESCONHECIDO)
            {
                int passos2 = abs(this->posX - i) + abs(this->posY - j);
                if(passos2 < passos)
                {
                    passos = passos2;
                    this->destX = i;
                    this->destY = j;
                }
            }

    return passos < 1000;
}

