/*
  BCC CHALLENGE 2 -- mar/abr 2010 -
  Bacharelado em Ciencia da Computacao
  Universidade Federal do Parana
  Lauro Luis Costa -- 'Dusty4'
*/


#include "crianca.h"
#include "campo.h"
#include "atributos.h"
#include "comandos.h"
#include "conteudos.h"
#include <stdlib.h>
#include <stdio.h>


Crianca::Crianca(int id,int x, int y)
{
    this->id = id;
    this->agachado = false;
    this->tonta = false;
    this->posX = x;
    this->posY = y;
    this->segurando = NADA;
    this->tonta = 0;
    this->mudar = false;
    this->pilha = new Pilha_de_acoes();
}

int Crianca::getPosX()
{
    return this->posX;
}

int Crianca::getPosY()
{
    return this->posY;
}

char Crianca::getSegurando()
{
    return this->segurando;
}

int Crianca::getTonta()
{
    return this->tonta;
}

bool Crianca::isTonta()
{
    if(this->tonta > 0)
    {
        this->pilha->empilhar(new Acao(PARADO, NPARADO));
        return true;
    }
    return false;
}



bool Crianca::isAgachado()
{
    return agachado;
}

void Crianca::setAgachado(bool a)
{
    this->agachado = a;
}

void Crianca::setSegurando(char h)
{
    this->segurando = h;
}

void Crianca::setPosXY(int x, int y)
{
    this->posX = x;
    this->posY =  y;
}

void Crianca::setTonta(int n)
{
    this->tonta = n;
}

/*retorna uma coordenada aleatoria, mas dentro do campo
a partir de uma posicao original e uma distancia max*/
int Crianca::destAleatoria(int p0, int distMax)
{
    int dest = random() % 2 == 0 ? p0 + (random() % distMax) : p0 - (random() % distMax);
    if(dest > 30)
        dest = 30;
    else if(dest < 0)
        dest = 0;

    return dest;
}

/*procura um objeto e devolve a coord do mais prox*/
bool Crianca::procuraObj(int *x, int *y, int visao, int obj, Campo *c)
{
    int resX[10];
    int resY[10];
    int n = 0;
/*possivel otimizar*/
    for(int i = 0; i < 31 && n < 10; i++)
        for(int j = 0; j < 31 && n < 10; j++)
            if(c->distEucl(this->posX, this->posY, i, j) <= visao)
                if(c->getLocal(i, j)/10 == obj/10)
                {
                    resX[n] = i;
                    resY[n++] = j;
                }
    if(n-- == 0)
        return false;

    /*vou retornar o mais proximo*/
    *x = resX[n];
    *y = resY[n--];

    while(n >= 0)
    {
        if(c->distEucl(this->posX, this->posY, *x, *y) > c->distEucl(this->posX, this->posY,resX[n], resY[n]))
        {
            *x = resX[n];
            *y = resY[n];
        }
        n--;
    }
    return true;
}
/*multiplica o compr do vetor X0 X1 em d vezes*/
void Crianca::posAlem(int x0, int y0, int *x1, int *y1, int d)
{
    int dx = (*x1 - x0) * d;
    int dy = (*y1 - y0) * d;
    *x1 = x0 + dx;
    *y1 = y0 + dy;
}
void Crianca::posAlem(int *x, int *y, int d)
{
        this->posAlem(this->posX, this->posY, x, y, d);
}

/*neve solta para pegar(mais proximo possivel de (xc, yc))*/
bool Crianca::procurarNeve(int *x, int *y, int tipo, int altura, Campo *c, int xc, int yc)
{
    float dist, dist2;
    dist = 100;
    for(int i = this->posX - 1; i <= this->posX + 1; i++)
        for(int j = this->posY - 1; j <= this->posY + 1; j++)
            if(this->coordValida(i, j)
            && !(i == this->posX && j == this->posY) &&
               c->getLocal(i, j)/10 == tipo/10 &&
               c->getLocal(i, j)%10 >= altura)
            {
                dist2 = c->distEucl(i, j, xc, yc);
                if(dist2 < dist)
                {
                    *x = i;
                    *y = j;
                    c->setLocal(i, j, c->getLocal(i, j) - altura);
                    dist = dist2;
                }

            }

    return dist < 100;
}

/*neve solta para pegar*/
bool Crianca::procurarNeve(int *x, int *y, int tipo, int altura, Campo *c)
{
    for(int i = this->posX - 1; i <= this->posX + 1; i++)
        for(int j = this->posY - 1; j <= this->posY + 1; j++)
            if(this->coordValida(i, j)
            && !(i == this->posX && j == this->posY) &&
               c->getLocal(i, j)/10 == tipo/10 &&
               c->getLocal(i, j)%10 >= altura)
            {
                *x = i;
                *y = j;
                c->setLocal(i, j, c->getLocal(i, j) - altura);
                return true;
            }
    return false;
}

/*verifica se x,y esta dentro do campo*/
bool Crianca::coordValida(int x, int y)
{
    return (x >= 0 && x <= 30 && y >=0 && y <=30);
}

bool Crianca::verificaPasso(Campo *c, int dx, int dy)
{
    /*precisa estar em pe para andar*/
    if(this->agachado)
        return false;

    /*o passo eh invalido*/
    if(c->distEucl(this->posX, this->posY, dx, dy) > 2)
        return false;

    /*nao pode andar em pos com altura maior ou igual 6*/
    if(c->obstaculoEm(this->posX, this->posY, dx, dy))
        return false;

    return true;
}


bool Crianca::verificaPasso_ag(Campo *c, int dx, int dy)
{
    /*deve estar agachado*/
    if(!this->agachado)
        return false;
    /*o passo e valido*/
    if(c->distEucl(this->posX, this->posY, dx, dy) > 1)
        return false;
    /*tem obstaculo no caminho?*/
    if(c->getAltura(dx, dy) >= 6)
        return false;

    return true;
}
/*coordenada atingivel proxima*/
void Crianca::aproximar(int *x, int *y, int altura, Campo *c)
{
    float dist, dist2;
    int dx, dy;
    dx = *x;
    dy = *y;
    bool b = false;
    for(int k = 1; !b; k++)
    {
        for(int i = dx - k; i <= dx + k; i++)
        {
            for(int j = dy - k; j <= dy + k; j++)
            {
                if(this->coordValida(i, j) && c->getAltura(i, j) < altura)
                {
                    dist2 = c->distEucl(this->posX, this->posY, i, j);

                    if(!b || dist2 < dist)
                    {
                        *x = i;
                        *y = j;
                        dist = dist2;
                        b = true;
                    }
                }
            }
        }
    }
}
/*planeja o caminho da posAtual p Dest*/
void Crianca::caminhada(Campo *c)
{
    this->caminhada(c, this->destX, this->destY, false);
    if(this->agachado)
        this->pilha->empilhar(new Acao(LEVANTAR, NLEVANTAR));
}

/*planeja o caminho da posAtual p Dest, agachado*/
void Crianca::caminhada_ag(Campo *c)
{
    this->caminhada(c, this->destX, this->destY, true);
    if(!this->agachado)
        this->pilha->empilhar(new Acao(AGACHAR, NAGACHAR));
}

void Crianca::caminhada(Campo *c, int dx, int dy, bool a)
{
    int caminhoX[CAMPO_SZ * CACHE_SZ];
    int caminhoY[CAMPO_SZ * CACHE_SZ];
    if(c->distEucl(this->posX, this->posY, dx, dy) < 2)
    {
        dx = this->destX = this->destAleatoria(this->posX, RANDMAX);
        dy = this->destY = this->destAleatoria(this->posY, RANDMAX);
    }
    if(c->getAltura(dx, dy) >= 6)
        this->aproximar(&dx, &dy, 6, c);
    /*nao posso ir exatamenet ateh la, vou aproximar*/

    /*se nao encontro destino, escolho destino aleatorio*/
    while(!c->constroiCaminho(this->posX, this->posY, dx, dy, caminhoX, caminhoY, a))
    {
        this->pilha->esvaziar();
        //this->pilha->empilhar(new Acao(PARADO, NPARADO));
        //return;
        dx = this->destX = this->destAleatoria(this->posX, RANDMAX);
        dy = this->destY = this->destAleatoria(this->posY, RANDMAX);

    }

    int i = 0;
    while(caminhoX[i] != this->posX || caminhoY[i] != this->posY)
    {
        if(!a)
            this->pilha->empilhar(new Acao(ANDAR, NANDAR, caminhoX[i], caminhoY[i]));
        else
            this->pilha->empilhar(new Acao(ANDAR_AG, NANDAR_AG, caminhoX[i], caminhoY[i]));
        i++;
    }

}
/*apenas para manter compatibilidade com classes antigas*/
bool Crianca::verificarArremessar(Campo *c)
{
    return this->verificarArremessar(c, &(this->alvoX), &(this->alvoY));
}

/*procura o inimigo atingivel mais proximo*/
/*calcula o tiro ou retorna falso*/
bool Crianca::verificarArremessar(Campo *c, int *x, int *y)
{
    int p = -1;
    float dist = 12; /*deve ser mais perto do que 12 para arremessar(pq eu quero)*/
    int alvoTonto = 4;
    bool alvoIndefeso = false;
    char s;


    for(int i = N_CRIANCAS; i < N_CRIANCAS * 2; i++)
    {
        /*primeiro, deve estar visivel*/
        if(c->getVisivel_cache(i))
        {
            /*preferencia por alvo nao tonto, politica de distribuir fogo igualmente*/
            if(alvoTonto < c->getTonta_cache(i))
                continue;
            s = c->getSegurando_cache(i);
            /*dou chance apenas para quem esta muito tonto*/
            if(alvoIndefeso && !(s == PEQ3 || s == MED || s == GRN || s == SOLTA1 || s == SOLTA2 || s == SOLTA3 || c->getTonta_cache(i) == 1))
                continue; /*show no mercy*/
            /*candidato a alvo*/
            int alvoX1 = c->getPosX_cache(i);
            int alvoY1 = c->getPosY_cache(i);
            float dist2 = c->distEucl(posX, posY, alvoX1, alvoY1);
            /*se o alvo esta mais perto do que eu ja tenho ou menos tonto mas dentro da dist aceitavel 12*/
            if(dist2 < dist || (alvoTonto > c->getTonta_cache(i) && dist2 < 12))
            {
                int alvo = c->getLocal(alvoX1, alvoY1);
                this->posAlem(&alvoX1, &alvoY1, 2);
                /*por ultimo, ver se o tiro eh possivel*/
                if(c->verificarAcerto(posX, posY, alvoX1, alvoY1, this->agachado ? 6 : 9, alvo))
                {
                    p = i;
                    dist = dist2;
                    *x = alvoX1;
                    *y = alvoY1;
                    alvoTonto = c->getTonta_cache(p);
                    /*nao considero alvos 'muito' tontos como indefesos por causa da politica de distribuir fogo igualmente,
                    se tonto(1) eh a hora de bater para manter tonto*/
                    if(!alvoIndefeso && c->getTonta_cache(p) < 2 && (c->getTonta_cache(p) == 1 || s == PEQ3 || s == MED || s == GRN || s == SOLTA1 || s == SOLTA2 || s == SOLTA3))
                        alvoIndefeso = true;
                }
            }
        }
    }
    return p != -1;
}

/*apenas para manter compatibilidade com classes antigas*/
bool Crianca::verificarArremessarRev(Campo *c)
{
    return this->verificarArremessarRev(c, &(this->alvoX), &(this->alvoY));
}
/*supondo a forma como o inimigo pensa, tenta pegar a bola arremessada*/
bool Crianca::verificarArremessarRev(Campo *c, int *x, int *y)
{
    int p;
    float dist;
    float dist2, dist3 = 12;
    int adv = -1;
    /*criancas J sao inimigas, I amigas*/
    for(int j = N_CRIANCAS; j <  N_CRIANCAS * 2; j++)
    {
        p = -1;
        dist = 12;/*deve ser mais perto do que 12 para arremessar(pq eu quero)*/
        if(!c->getVisivel_cache(j))
            continue;
        if(c->getTonta_cache(j) > 0)
            continue;
        char seg = c->getSegurando_cache(j);
        if(seg != PEQ1 && seg != PEQ2 && seg != PEQ3)
            continue;
        int posX = c->getPosX_cache(j);
        int posY = c->getPosY_cache(j);
        /*nesse ponto, sei que o inimigo esta visivel, armado e nao esta tonto*/
        for(int i = 0; i < N_CRIANCAS ; i++)
        {
            int alvoX1 = c->getPosX_cache(i);
            int alvoY1 = c->getPosY_cache(i);
            dist2 = c->distEucl(posX, posY, alvoX1, alvoY1);
            /*se o alvo esta mais perto do que eu ja tenho ou se e o primeiro que tenho*/
            if(dist2 < dist)
            {
                int alvo = c->getLocal(alvoX1, alvoY1);
                this->posAlem(posX, posY, &alvoX1, &alvoY1, 2);
                /*se nao ha colisoes e eh o mais proximo, este e meu alvo*/
                if(c->verificarAcerto(posX, posY, alvoX1, alvoY1, c->getAlturaObj_cache(j), alvo))
                {
                    p = i;
                    dist = dist2;
                }
            }
        }
        /*vai atirar em mim?*/
        if(this->id == p && dist < dist3)
        {
            dist3 = dist;
            adv = j;
        }

    }
    if(adv != -1)
    {
        *x = c->getPosX_cache(adv);
        *y = c->getPosY_cache(adv);
        return true;
    }
    return false;
}
