/*
  BCC CHALLENGE 2 -- mar/abr 2010 -
  Bacharelado em Ciencia da Computacao
  Universidade Federal do Parana
  Lauro Luis Costa -- 'Dusty4'
*/


#ifndef CRIANCA_H_INCLUDED
#define CRIANCA_H_INCLUDED
#include "pilha_de_acoes.h"
#include "acao.h"
#include "campo.h"
#define RANDMAX 5

/*crianca e apenas uma classe base para criancas com estrategias especificas*/

class Crianca
{
	public:
		Crianca(int id, int x, int y);
		int getPosX();
		int getPosY();
		char getSegurando();
		int getTonta();
        bool isAgachado();
        bool isTonta();
        void setPosXY(int x, int y);
        void setTonta(int n);
        void setAgachado(bool a);
        void setSegurando(char h);
        void aproximar(int *x, int *y, int altura, Campo *c);
        virtual void jogue(Campo *c, int rodada, int placar)=0;
        bool mudar;
	protected:
        Pilha_de_acoes *pilha;
        int id;
        int posX;
        int posY;
        bool agachado;
        int tonta;
        char segurando;
        int destX;
        int destY;
        int alvoX;
        int alvoY;
        virtual void nova_pilha(Campo *c, int rodada, int placar)=0;
        void caminhada(Campo *c);
        void caminhada(Campo *c, int dx, int dy, bool agachado);
        void caminhada_ag(Campo *c);
        int destAleatoria(int p0, int distMax);
        bool procuraObj(int *x, int *y, int visao, int obj, Campo *c);
        void posAlem(int *x, int *y, int d);
        void posAlem(int x0, int y0, int *x1, int *y1, int d);
        bool procurarNeve(int *x, int *y, int tipo, int altura, Campo *c);
        bool procurarNeve(int *x, int *y, int tipo, int altura, Campo *c, int xc, int yc);
        bool coordValida(int x, int y);
        bool verificaPasso(Campo *c, int dx, int dy);
        bool verificaPasso_ag(Campo *c, int dx, int dy);
        bool verificarArremessar(Campo *c);
        bool verificarArremessar(Campo *c, int *x, int *y);
		bool verificarArremessarRev(Campo *c);
		bool verificarArremessarRev(Campo *c, int *x, int *y);



};



#endif // CRIANCA_H_INCLUDED
