/*
  BCC CHALLENGE 2 -- mar/abr 2010 -
  Bacharelado em Ciencia da Computacao
  Universidade Federal do Parana
  Lauro Luis Costa -- 'Dusty4'
*/


#include "pilha_de_acoes.h"
#include "comandos.h"

Pilha_de_acoes::Pilha_de_acoes()
{
    this->topo = -1;
}

void Pilha_de_acoes::empilhar(Acao* a)
{
    if(this->topo + 1 >= this->limite)
        this->esvaziar();

    this->acoes[++this->topo] = a;
}

Acao* Pilha_de_acoes::desempilhar()
{
    if(this->isVazia())
        return new Acao(PARADO, NPARADO);

    return this->acoes[this->topo--];
}

bool Pilha_de_acoes::isVazia()
{
    return this->topo < 0;
}

void Pilha_de_acoes::esvaziar()
{
    while(!this->isVazia())
        delete desempilhar();
}

/*retorna uma copia do topo, sem desempilhar*/
Acao* Pilha_de_acoes::copiaTopo()
{
    if(this->isVazia())
        return new Acao(PARADO, NPARADO);

    return this->acoes[this->topo];
}
